From 9c1dd238503e7347b4ca08709a2214d32b7322ad Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Tue, 22 Jan 2019 09:33:17 +0100
Subject: [PATCH] general: remove support for "iframe" mode (#29955)

---
 data/vendor/effective_tld_names.dat    | 11132 -----------------------
 tests/test_misc.py                     |     6 -
 wcs/publisher.py                       |     5 -
 wcs/qommon/http_response.py            |    11 -
 wcs/qommon/ident/idp.py                |     6 -
 wcs/qommon/publisher.py                |    43 +-
 wcs/qommon/vendor/etld.py              |    65 -
 wcs/templates/wcs/formdata_status.html |     2 -
 8 files changed, 2 insertions(+), 11268 deletions(-)
 delete mode 100644 data/vendor/effective_tld_names.dat
 delete mode 100644 wcs/qommon/vendor/etld.py

diff --git a/tests/test_misc.py b/tests/test_misc.py
index b802f3470..241c99b7a 100644
--- a/tests/test_misc.py
+++ b/tests/test_misc.py
@@ -256,12 +256,6 @@ def test_get_as_datetime():
     assert get_as_datetime('2017-04-25T12:00:00') == datetime_value
     assert get_as_datetime('25/04/2017 12:00') == datetime_value
 
-def test_etld():
-    pub = create_temporary_pub()
-    pub.load_effective_tld_names()
-    assert pub.etld.parse('www.example.net') == ('www.example', 'net')
-    assert pub.etld.parse('www.example.rhcloud.com') == ('www.example', 'rhcloud.com')
-
 def test_pagination():
     pub = create_temporary_pub()
     req = HTTPRequest(None, {'SERVER_NAME': 'example.net', 'SCRIPT_NAME': ''})
diff --git a/wcs/publisher.py b/wcs/publisher.py
index 8d8deb489..5eaa4bf46 100644
--- a/wcs/publisher.py
+++ b/wcs/publisher.py
@@ -253,11 +253,6 @@ class WcsPublisher(StubWcsPublisher):
         z.close()
         return results
 
-    def init_publish(self, request):
-        if request.get_header('X_WCS_IFRAME_MODE', '') in ('true', 'yes'):
-            request.response.iframe_mode = True
-        return QommonPublisher.init_publish(self, request)
-
     def get_object_visitors(self, object_key):
         session_manager = self.session_manager_class(session_class=self.session_class)
         return session_manager.session_class.get_object_visitors(object_key)
diff --git a/wcs/qommon/http_response.py b/wcs/qommon/http_response.py
index 0d03894aa..e3c9cc3d1 100644
--- a/wcs/qommon/http_response.py
+++ b/wcs/qommon/http_response.py
@@ -35,7 +35,6 @@ class AfterJob(StorableObject):
 
 
 class HTTPResponse(quixote.http_response.HTTPResponse):
-    iframe_mode = False
     javascript_scripts = None
     javascript_code_parts = None
     css_includes = None
@@ -47,16 +46,6 @@ class HTTPResponse(quixote.http_response.HTTPResponse):
         if not charset:
             self.charset = get_publisher().site_charset
 
-    def redirect(self, location, permanent=False):
-        if not self.iframe_mode:
-            return quixote.http_response.HTTPResponse.redirect(self, location, permanent)
-        req = get_request()
-        server_url = '%s://%s' % (req.get_scheme(), req.get_server())
-        if location.startswith(server_url):
-            iframe_server_url = '%s://%s' % (req.get_scheme(), req.get_server(clean=False))
-            location = iframe_server_url + location[len(server_url):]
-        return quixote.http_response.HTTPResponse.redirect(self, location, permanent)
-
     def reset_includes(self):
         self.javascript_scripts = None
         self.javascript_code_parts = None
diff --git a/wcs/qommon/ident/idp.py b/wcs/qommon/ident/idp.py
index 7a7f45651..80d6bcd41 100644
--- a/wcs/qommon/ident/idp.py
+++ b/wcs/qommon/ident/idp.py
@@ -1058,12 +1058,6 @@ class IdPAuthMethod(AuthMethod):
     def login(self):
         idps = get_cfg('idp', {})
 
-        if get_response().iframe_mode and not get_request().form.get('next'):
-            get_request().form = {'next': '%s://%s%s' % (
-                    get_request().get_scheme(),
-                    get_request().get_server(False),
-                    get_publisher().get_root_url())}
-
         # there is only one visible IdP, perform login automatically on
         # this one.
         server = misc.get_lasso_server()
diff --git a/wcs/qommon/publisher.py b/wcs/qommon/publisher.py
index 1a038da11..9f5f6d3ec 100644
--- a/wcs/qommon/publisher.py
+++ b/wcs/qommon/publisher.py
@@ -456,19 +456,6 @@ class QommonPublisher(Publisher, object):
         if request:
             if request.get_scheme() == 'https':
                 self.config.session_cookie_secure = True
-            canonical_hostname = request.get_server(clean = False).lower().split(':')[0].rstrip('.')
-            if canonical_hostname.count('.') >= 2 and self.etld:
-                try:
-                    socket.inet_aton(canonical_hostname)
-                except socket.error:
-                    # not an IP address
-                    try:
-                        base_name = self.etld.parse(canonical_hostname)[1]
-                    except:
-                        pass
-                    else:
-                        self.config.session_cookie_domain = '.'.join(
-                                canonical_hostname.split('.')[-2-base_name.count('.'):])
 
         md5_hash = hashlib.md5()
         md5_hash.update(self.app_dir)
@@ -494,7 +481,7 @@ class QommonPublisher(Publisher, object):
         Set the application directory, creating it if possible and authorized.
         '''
         canonical_hostname = request.get_server(clean = False).lower().split(':')[0].rstrip('.')
-        for prefix in ['iframe', 'mobile', 'm']:
+        for prefix in ['mobile', 'm']:
             if canonical_hostname.startswith(prefix + '.') or \
                     canonical_hostname.startswith(prefix + '-'):
                 canonical_hostname = canonical_hostname[len(prefix)+1:]
@@ -503,8 +490,6 @@ class QommonPublisher(Publisher, object):
         self.app_dir = os.path.join(self.APP_DIR, canonical_hostname)
 
         if script_name:
-            if script_name.startswith('iframe.'):
-                script_name = script_name[7:]
             script_name = script_name.replace('/', '+')
             self.app_dir += '+' + script_name
 
@@ -551,23 +536,15 @@ class QommonPublisher(Publisher, object):
 
         self.initialize_app_dir()
 
-        # possibility to enable iframe mode via SCRIPT_NAME
-        script_name = request.get_header('SCRIPT_NAME', '').strip('/')
-        if script_name.startswith('iframe.'):
-            request.response.page_template_key = 'iframe'
-
         # determine appropriate theme variant
         canonical_hostname = request.get_server(False).lower().split(':')[0].rstrip('.')
         override_template_keys = {'m': 'mobile'}
-        for prefix in ['iframe', 'mobile', 'm']:
+        for prefix in ['mobile', 'm']:
             if canonical_hostname.startswith(prefix + '.') or \
                     canonical_hostname.startswith(prefix + '-'):
                 request.response.page_template_key = override_template_keys.get(prefix, prefix)
                 break
 
-        if request.response.page_template_key == 'iframe':
-            request.response.iframe_mode = True
-
         self.set_config(request)
 
         if request.get_cookie('mobile') == 'false':
@@ -734,17 +711,6 @@ class QommonPublisher(Publisher, object):
                 except OSError:
                     pass
 
-    @classmethod
-    def load_effective_tld_names(cls):
-        if hasattr(cls, 'etld') and cls.etld:
-            return
-        filename = os.path.join(cls.DATA_DIR, 'vendor', 'effective_tld_names.dat')
-        if not os.path.exists(filename):
-            cls.etld = None
-            return
-        from vendor import etld
-        cls.etld = etld.etld(filename)
-
     @classmethod
     def register_cronjobs(cls):
         cls.register_cronjob(CronJob(cls.clean_sessions, minutes=range(0, 60, 5)))
@@ -752,8 +718,6 @@ class QommonPublisher(Publisher, object):
         cls.register_cronjob(CronJob(cls.clean_afterjobs, hourly=True))
         cls.register_cronjob(CronJob(cls.clean_tempfiles, hourly=True))
 
-    register_tld_names = False
-
     _initialized = False
     @classmethod
     def init_publisher_class(cls):
@@ -762,9 +726,6 @@ class QommonPublisher(Publisher, object):
         cls._initialized = True
         cls.load_extra_dirs()
 
-        if cls.register_tld_names:
-            cls.load_effective_tld_names()
-
     @classmethod
     def create_publisher(cls, **kwargs):
         publisher = cls(cls.root_directory_class(),
